﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace GettingStarted
{
    public class BookInfo : INotifyPropertyChanged
    {
        #region Fields

        private string bookName;
        private string bookDesc;
        private bool overalyVisible =false;
        private bool templateVisible = true;
        private Color color = Color.Accent;



        #endregion

        #region Constructor

        public BookInfo()
        {

        }

        #endregion

        #region Properties

        public Color Color
        {
            get { return color; }
            set
            {
                this.color= value;
                OnPropertyChanged("Color");
            }
        }
        public bool OveralyVisible
        {
            get { return overalyVisible; }
            set { this.overalyVisible = value;
                OnPropertyChanged("OveralyVisible");
            }
        }
        public bool TemplateVisible
        {
            get { return templateVisible; }
            set { this.templateVisible = value;
                OnPropertyChanged("TemplateVisible");
            }
        }
        public string BookName
        {
            get { return bookName; }
            set
            {
                bookName = value;
                OnPropertyChanged("BookName");
            }
        }

        public string BookDescription
        {
            get { return bookDesc; }
            set
            {
                bookDesc = value;
                OnPropertyChanged("BookDescription");
            }
        }

        #endregion

        #region Interface Member

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        #endregion
    }
}
